 ; PGE20 Pretty Good Envelope v2.0
 ; Copyright 4/27/98
 ; by Robert G. Durnal
TITLE PGE20
PAGE 60
 .model tiny
 .radix 16
 .386
 _code segment use16
readsize equ 8000
readbuf equ 1000
 assume cs:_code,ds:_code,es:_code
 org 100
START:
 mov si,80
 lodsb
 or al,al
 jz short prog
 call docscreen
PROG:
 mov dx,offset getenv
 call getfile  ; Open envelope file
 push bx ; Handle #1
 mov ax,4202
 xor cx,cx
 mov dx,cx
 int 21        ; Find length
 push dx       ;  and save MSB
 push ax       ; LSB
 mov dx,offset getmsg
 call getfile  ; Get message file
 mov ah,3F
 mov cx,readsize
 mov dx,readbuf
 int 21        ;  and read to READBUF
 mov dx,offset readerr
 jc short filerror
 mov cx,ax
 add cx,4      ; CX is new file size
 add ax,readbuf
 xchg di,ax
 pop ax
 stosw         ; Store envelope size
 pop ax
 stosw
 mov ah,40
 pop bx        ; Back to envelope file
 mov dx,readbuf
 int 21        ;  and append message
 mov dx,offset writerr
 jc short filerr1
 mov ah,3e     ; Close envelope file
 int 21
DONE:
 int 20        ; End program
FILERROR:
 mov ah,9
 int 21
 mov dx,offset fnamebuf+2
FILERR1:
 mov ah,9
 int 21
 int 20
GETFILE:
 mov ah,9      ; DX must be preset
 int 21
 mov ah,0A
 mov dx,offset fnamebuf
 int 21        ; Get file name from KB
 xchg bx,dx
 mov al,byte ptr [bx+1]
 cbw
 add bx,ax
 mov word ptr [bx+2],2400 ; ASCIZZ
 mov ax,3D02
 mov dx,offset fnamebuf+2
 int 21
 mov dx,offset openerr
 jc filerror
 xchg ax,bx    ; Handle in BX
 ret
DOCSCREEN: ; Subroutine to 
 ; search environment block
 ; for PATH variable, search
 ; for PGE20.DOC in path
 mov ax,3D00 ; Check current dir
 mov dx,offset fnamebuf+2
 int 21
 xchg ax,bx
 jnc short docscr1
 call openpath
DOCSCR1:
 mov ah,3F
 mov dx,readbuf
 mov cx,readsize
 int 21
 mov dx,offset readerr
 jc filerror
 mov dx,readbuf
 mov ah,9
 int 21
 ret
OPENPATH:
 xor si,si
FINDLOOP:
 db 8E,1E,2C,00 ; mov ds,[2c]
 lodsd
 cmp eax,48544150 ; 'HTAP'
 jz short pathfound
FINDZERO: 
 lodsb
 or al,al
 jnz findzero
 lodsb
 dec si
 or al,al
 jnz findloop
ENDOFENV:
 push es
 pop ds ; Restore DS before quit
 mov dx,offset nopath
 mov ah,9
 int 21
 mov dx,offset fnamebuf+2
 int 21
 jmp done
PATHFOUND:
 lodsb
 cmp al,'='
 jnz findzero ; Not the right PATH
NEXTPATH:
 db 8E,1E,2C,00 ; mov ds,[2c]
 cmp byte ptr [si-1],0
 jz endofenv ; Dir was last in PATH
 mov di,offset pathbuf
PATHLOOP:
 lodsb
 stosb
 or al,al
 jz short pl1
 cmp al,';'
 jnz pathloop
PL1:
 dec di
 mov al,'\'
 stosb
 push es
 pop ds ; Restore DS 
 push si
 mov si,offset fnamebuf+2
 mov dx,offset pathbuf
GETFNAME:
 lodsb
 stosb
 cmp al,'$'
 jnz getfname
 pop si
 mov ax,3D00
 int 21
 jc nextpath
 mov bx,ax   ; handle
 ret
OPENERR:
 db 0Dh,0A,'Error opening file $'
READERR:
 db 0Dh,0A,'Error reading file $'
WRITERR:
 db 0Dh,0A,'Error writing to output file$'
GETENV:
 db 'Envelope file name: $'
GETMSG:
 db 0Dh,0A,'Message file name: $'
NOPATH:
 db 0Dh,0A,'No path found for $'
FNAMEBUF:
 db 25 ; 36 char file spec
 db 0Bh,'PGE20.DOC',0,24
PATHBUF:
 db 24 dup(0)
 end start
 